
;CodeVisionAVR C Compiler V2.04.4a Advanced
;(C) Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega32
;Program type             : Application
;Clock frequency          : 16,000000 MHz
;Memory model             : Small
;Optimize for             : Speed
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 512 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : Off
;Automatic register allocation : Off

	#pragma AVRPART ADMIN PART_NAME ATmega32
	#pragma AVRPART MEMORY PROG_FLASH 32768
	#pragma AVRPART MEMORY EEPROM 1024
	#pragma AVRPART MEMORY INT_SRAM SIZE 2048
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _adc_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x800)
	LDI  R25,HIGH(0x800)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x85F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x85F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x260)
	LDI  R29,HIGH(0x260)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x260

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.04.4a Advanced
;Automatic Program Generator
; Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project : DigitMag1
;Version : 1.05
;Date    : 29.01.2010
;Author  : RA9YTJ
;Company : home
;Comments:
;
;
;Chip type               : ATmega32
;Program type            : Application
;AVR Core Clock frequency: 16,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 512
;*****************************************************/
;
;#include <mega32.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <sleep.h>
;#include <delay.h>
;#include <spi.h>
;
;#define ADC_VREF_TYPE 0x20
;
;
;char i,mode,flag,rec,m1,m2,m3,m4,m5,m6;
;unsigned int index;
;unsigned long carentsector,MaxSector,MaxSector1,sec,fullsectors,sizef;
;unsigned long StartSec[6];
;char bufa[512];
;char bufb[512];
;
;// ADC interrupt service routine
;interrupt [ADC_INT] void adc_isr(void)
; 0000 0029 {

	.CSEG
_adc_isr:
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 002A unsigned char adc_data;
; 0000 002B adc_data=ADCH;
	ST   -Y,R16
;	adc_data -> R16
	IN   R16,5
; 0000 002C {
; 0000 002D if (PINC.6)
	SBIS 0x13,6
	RJMP _0x3
; 0000 002E  rec=0;
	LDI  R30,LOW(0)
	RJMP _0x9F
; 0000 002F else
_0x3:
; 0000 0030  if (rec<250) rec++;
	LDS  R26,_rec
	CPI  R26,LOW(0xFA)
	BRSH _0x5
	LDS  R30,_rec
	SUBI R30,-LOW(1)
_0x9F:
	STS  _rec,R30
; 0000 0031 
; 0000 0032 if (PINC.0)
_0x5:
	SBIS 0x13,0
	RJMP _0x6
; 0000 0033  m1=0;
	LDI  R30,LOW(0)
	RJMP _0xA0
; 0000 0034 else
_0x6:
; 0000 0035  if (m1<250) m1++;
	LDS  R26,_m1
	CPI  R26,LOW(0xFA)
	BRSH _0x8
	LDS  R30,_m1
	SUBI R30,-LOW(1)
_0xA0:
	STS  _m1,R30
; 0000 0036 
; 0000 0037 if (PINC.1)
_0x8:
	SBIS 0x13,1
	RJMP _0x9
; 0000 0038  m2=0;
	LDI  R30,LOW(0)
	RJMP _0xA1
; 0000 0039 else
_0x9:
; 0000 003A  if (m2<250) m2++;
	LDS  R26,_m2
	CPI  R26,LOW(0xFA)
	BRSH _0xB
	LDS  R30,_m2
	SUBI R30,-LOW(1)
_0xA1:
	STS  _m2,R30
; 0000 003B 
; 0000 003C if (PINC.2)
_0xB:
	SBIS 0x13,2
	RJMP _0xC
; 0000 003D  m3=0;
	LDI  R30,LOW(0)
	RJMP _0xA2
; 0000 003E else
_0xC:
; 0000 003F  if (m3<250) m3++;
	LDS  R26,_m3
	CPI  R26,LOW(0xFA)
	BRSH _0xE
	LDS  R30,_m3
	SUBI R30,-LOW(1)
_0xA2:
	STS  _m3,R30
; 0000 0040 
; 0000 0041 if (PINC.3)
_0xE:
	SBIS 0x13,3
	RJMP _0xF
; 0000 0042  m4=0;
	LDI  R30,LOW(0)
	RJMP _0xA3
; 0000 0043 else
_0xF:
; 0000 0044  if (m4<250) m4++;
	LDS  R26,_m4
	CPI  R26,LOW(0xFA)
	BRSH _0x11
	LDS  R30,_m4
	SUBI R30,-LOW(1)
_0xA3:
	STS  _m4,R30
; 0000 0045 
; 0000 0046 if (PINC.4)
_0x11:
	SBIS 0x13,4
	RJMP _0x12
; 0000 0047  m5=0;
	LDI  R30,LOW(0)
	RJMP _0xA4
; 0000 0048 else
_0x12:
; 0000 0049  if (m5<250) m5++;
	LDS  R26,_m5
	CPI  R26,LOW(0xFA)
	BRSH _0x14
	LDS  R30,_m5
	SUBI R30,-LOW(1)
_0xA4:
	STS  _m5,R30
; 0000 004A 
; 0000 004B if (PINC.5)
_0x14:
	SBIS 0x13,5
	RJMP _0x15
; 0000 004C  m6=0;
	LDI  R30,LOW(0)
	RJMP _0xA5
; 0000 004D else
_0x15:
; 0000 004E  if (m6<250) m6++;
	LDS  R26,_m6
	CPI  R26,LOW(0xFA)
	BRSH _0x17
	LDS  R30,_m6
	SUBI R30,-LOW(1)
_0xA5:
	STS  _m6,R30
; 0000 004F 
; 0000 0050 }
_0x17:
; 0000 0051  switch (mode)
	LDS  R30,_mode
	LDI  R31,0
; 0000 0052  {
; 0000 0053   case 1:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x1B
; 0000 0054   {
; 0000 0055   if (flag)
	LDS  R30,_flag
	CPI  R30,0
	BREQ _0x1C
; 0000 0056   {
; 0000 0057    OCR2=bufa[index];
	LDS  R30,_index
	LDS  R31,_index+1
	SUBI R30,LOW(-_bufa)
	SBCI R31,HIGH(-_bufa)
	RJMP _0xA6
; 0000 0058    index++;
; 0000 0059   }
; 0000 005A   else
_0x1C:
; 0000 005B   {
; 0000 005C   OCR2=bufb[index];
	LDS  R30,_index
	LDS  R31,_index+1
	SUBI R30,LOW(-_bufb)
	SBCI R31,HIGH(-_bufb)
_0xA6:
	LD   R30,Z
	OUT  0x23,R30
; 0000 005D   index++;
	LDI  R26,LOW(_index)
	LDI  R27,HIGH(_index)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0000 005E   }
; 0000 005F }
; 0000 0060   break;
	RJMP _0x1A
; 0000 0061   case 2:
_0x1B:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x1E
; 0000 0062   {
; 0000 0063   if (flag)
	LDS  R30,_flag
	CPI  R30,0
	BREQ _0x1F
; 0000 0064   {
; 0000 0065    bufa[index]=adc_data;
	LDS  R30,_index
	LDS  R31,_index+1
	SUBI R30,LOW(-_bufa)
	SBCI R31,HIGH(-_bufa)
	RJMP _0xA7
; 0000 0066    index++;
; 0000 0067   }
; 0000 0068   else
_0x1F:
; 0000 0069   {
; 0000 006A    bufb[index]=adc_data;
	LDS  R30,_index
	LDS  R31,_index+1
	SUBI R30,LOW(-_bufb)
	SBCI R31,HIGH(-_bufb)
_0xA7:
	ST   Z,R16
; 0000 006B    index++;
	LDI  R26,LOW(_index)
	LDI  R27,HIGH(_index)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0000 006C   }
; 0000 006D  }
; 0000 006E  break;
	RJMP _0x1A
; 0000 006F  case 3: OCR2=adc_data;
_0x1E:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x1A
	OUT  0x23,R16
; 0000 0070  }
_0x1A:
; 0000 0071 if (index==512)
	LDS  R26,_index
	LDS  R27,_index+1
	CPI  R26,LOW(0x200)
	LDI  R30,HIGH(0x200)
	CPC  R27,R30
	BRNE _0x22
; 0000 0072 {
; 0000 0073   index=0;
	LDI  R30,LOW(0)
	STS  _index,R30
	STS  _index+1,R30
; 0000 0074   flag=~flag;
	LDS  R30,_flag
	COM  R30
	STS  _flag,R30
; 0000 0075  }
; 0000 0076 }
_0x22:
	LD   R16,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	RETI
;
;
;char card_Command(char cmdF, unsigned long Adr, char cmdH )
; 0000 007A {
_card_Command:
; 0000 007B  spi(0xFF);
;	cmdF -> Y+5
;	Adr -> Y+1
;	cmdH -> Y+0
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _spi
; 0000 007C  spi(cmdF);
	LDD  R30,Y+5
	ST   -Y,R30
	CALL _spi
; 0000 007D  spi((char)(Adr >> 24));
	__GETD2S 1
	LDI  R30,LOW(24)
	CALL __LSRD12
	ST   -Y,R30
	CALL _spi
; 0000 007E  spi((char)(Adr  >> 16));
	__GETD1S 1
	CALL __LSRD16
	ST   -Y,R30
	CALL _spi
; 0000 007F  spi((char)(Adr >> 8));
	__GETD2S 1
	LDI  R30,LOW(8)
	CALL __LSRD12
	ST   -Y,R30
	CALL _spi
; 0000 0080  spi((char)Adr);
	LDD  R30,Y+1
	ST   -Y,R30
	CALL _spi
; 0000 0081  spi(cmdH);
	LD   R30,Y
	ST   -Y,R30
	CALL _spi
; 0000 0082  spi(0xFF);
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _spi
; 0000 0083  return spi(0xFF);
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _spi
	ADIW R28,6
	RET
; 0000 0084 }
;
;char card_Init()
; 0000 0087 {
_card_Init:
; 0000 0088  char ii;
; 0000 0089  PORTB.4=1;
	ST   -Y,R16
;	ii -> R16
	SBI  0x18,4
; 0000 008A  for(ii=0; ii < 10; ii++) spi(0xFF);
	LDI  R16,LOW(0)
_0x26:
	CPI  R16,10
	BRSH _0x27
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _spi
	SUBI R16,-1
	RJMP _0x26
_0x27:
; 0000 008B PORTB.4=0;
	CBI  0x18,4
; 0000 008C  if (card_Command(0x40,0,0x95) != 1) return 1;
	LDI  R30,LOW(64)
	ST   -Y,R30
	__GETD1N 0x0
	CALL __PUTPARD1
	LDI  R30,LOW(149)
	ST   -Y,R30
	RCALL _card_Command
	CPI  R30,LOW(0x1)
	BREQ _0x2A
	LDI  R30,LOW(1)
	RJMP _0x2040005
; 0000 008D  while (card_Command(0x41,0,0xFF) !=0);
_0x2A:
_0x2B:
	LDI  R30,LOW(65)
	ST   -Y,R30
	__GETD1N 0x0
	CALL __PUTPARD1
	LDI  R30,LOW(255)
	ST   -Y,R30
	RCALL _card_Command
	CPI  R30,0
	BRNE _0x2B
; 0000 008E  return 0;
	LDI  R30,LOW(0)
_0x2040005:
	LD   R16,Y+
	RET
; 0000 008F }
;
;char card_ReadSector(unsigned long Sector, char *AdrBuf)
; 0000 0092 {
_card_ReadSector:
; 0000 0093  int ii;
; 0000 0094  PORTB.4=1;
	ST   -Y,R17
	ST   -Y,R16
;	Sector -> Y+4
;	*AdrBuf -> Y+2
;	ii -> R16,R17
	SBI  0x18,4
; 0000 0095  for(ii=0; ii < 10; ii++) spi(0xFF);
	__GETWRN 16,17,0
_0x31:
	__CPWRN 16,17,10
	BRGE _0x32
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _spi
	__ADDWRN 16,17,1
	RJMP _0x31
_0x32:
; 0000 0096 PORTB.4=0;
	CBI  0x18,4
; 0000 0097  if (card_Command(0x51,(Sector<<9),0xFF) != 0) return 1;
	LDI  R30,LOW(81)
	ST   -Y,R30
	__GETD2S 5
	LDI  R30,LOW(9)
	CALL __LSLD12
	CALL __PUTPARD1
	LDI  R30,LOW(255)
	ST   -Y,R30
	RCALL _card_Command
	CPI  R30,0
	BREQ _0x35
	LDI  R30,LOW(1)
	RJMP _0x2040003
; 0000 0098  while(spi(0xFF) != 0xFE);
_0x35:
_0x36:
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _spi
	CPI  R30,LOW(0xFE)
	BRNE _0x36
; 0000 0099  for(ii=0; ii < 512; ii++) *AdrBuf++=spi(0xFF);
	__GETWRN 16,17,0
_0x3A:
	__CPWRN 16,17,512
	BRGE _0x3B
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,1
	STD  Y+2,R30
	STD  Y+2+1,R31
	SBIW R30,1
	PUSH R31
	PUSH R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _spi
	POP  R26
	POP  R27
	ST   X,R30
	__ADDWRN 16,17,1
	RJMP _0x3A
_0x3B:
; 0000 009A spi(0xFF);
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _spi
; 0000 009B  spi(0xFF);
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _spi
; 0000 009C  return 0;
	RJMP _0x2040004
; 0000 009D }
;
;char card_WriteSector(unsigned long Sector, char *AdrBuf)
; 0000 00A0 {
_card_WriteSector:
; 0000 00A1  int ii;
; 0000 00A2  PORTB.4=1;
	ST   -Y,R17
	ST   -Y,R16
;	Sector -> Y+4
;	*AdrBuf -> Y+2
;	ii -> R16,R17
	SBI  0x18,4
; 0000 00A3  for(ii=0; ii < 10; ii++) spi(0xFF);
	__GETWRN 16,17,0
_0x3F:
	__CPWRN 16,17,10
	BRGE _0x40
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _spi
	__ADDWRN 16,17,1
	RJMP _0x3F
_0x40:
; 0000 00A4 PORTB.4=0;
	CBI  0x18,4
; 0000 00A5  if (card_Command(0x58,(Sector<<9),0xFF) !=0) return 1;
	LDI  R30,LOW(88)
	ST   -Y,R30
	__GETD2S 5
	LDI  R30,LOW(9)
	CALL __LSLD12
	CALL __PUTPARD1
	LDI  R30,LOW(255)
	ST   -Y,R30
	RCALL _card_Command
	CPI  R30,0
	BREQ _0x43
	LDI  R30,LOW(1)
	RJMP _0x2040003
; 0000 00A6  spi(0xFF);
_0x43:
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _spi
; 0000 00A7  spi(0xFF);
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _spi
; 0000 00A8  spi(0xFE);
	LDI  R30,LOW(254)
	ST   -Y,R30
	CALL _spi
; 0000 00A9  for (ii=0;ii<512; ii++) spi(*AdrBuf++);
	__GETWRN 16,17,0
_0x45:
	__CPWRN 16,17,512
	BRGE _0x46
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LD   R30,X+
	STD  Y+2,R26
	STD  Y+2+1,R27
	ST   -Y,R30
	CALL _spi
	__ADDWRN 16,17,1
	RJMP _0x45
_0x46:
; 0000 00AA spi(0xFF);
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _spi
; 0000 00AB  spi(0xFF);
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _spi
; 0000 00AC  if ((spi(0xFF)& 0x1F) != 0x05) return 2;
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _spi
	ANDI R30,LOW(0x1F)
	CPI  R30,LOW(0x5)
	BREQ _0x47
	LDI  R30,LOW(2)
	RJMP _0x2040003
; 0000 00AD  while(spi(0xFF) != 0xFF);
_0x47:
_0x48:
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _spi
	CPI  R30,LOW(0xFF)
	BRNE _0x48
; 0000 00AE  return 0;
_0x2040004:
	LDI  R30,LOW(0)
_0x2040003:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,8
	RET
; 0000 00AF }
;
;char GetB_RECORD()
; 0000 00B2 {
_GetB_RECORD:
; 0000 00B3  if (rec==250)
	LDS  R26,_rec
	CPI  R26,LOW(0xFA)
	BRNE _0x4B
; 0000 00B4   {
; 0000 00B5    rec=255;
	LDI  R30,LOW(255)
	STS  _rec,R30
; 0000 00B6    return 1;
	RJMP _0x2040002
; 0000 00B7    }
; 0000 00B8  return 0;
_0x4B:
	RJMP _0x2040001
; 0000 00B9 }
;
;char GetB_M()
; 0000 00BC {
_GetB_M:
; 0000 00BD if (m1==250)
	LDS  R26,_m1
	CPI  R26,LOW(0xFA)
	BRNE _0x4C
; 0000 00BE   {
; 0000 00BF    m1=255;
	LDI  R30,LOW(255)
	STS  _m1,R30
; 0000 00C0    return 1;
_0x2040002:
	LDI  R30,LOW(1)
	RET
; 0000 00C1    }
; 0000 00C2 if (m2==250)
_0x4C:
	LDS  R26,_m2
	CPI  R26,LOW(0xFA)
	BRNE _0x4D
; 0000 00C3   {
; 0000 00C4    m2=255;
	LDI  R30,LOW(255)
	STS  _m2,R30
; 0000 00C5    return 2;
	LDI  R30,LOW(2)
	RET
; 0000 00C6    }
; 0000 00C7 if (m3==250)
_0x4D:
	LDS  R26,_m3
	CPI  R26,LOW(0xFA)
	BRNE _0x4E
; 0000 00C8   {
; 0000 00C9    m3=255;
	LDI  R30,LOW(255)
	STS  _m3,R30
; 0000 00CA    return 3;
	LDI  R30,LOW(3)
	RET
; 0000 00CB    }
; 0000 00CC if (m4==250)
_0x4E:
	LDS  R26,_m4
	CPI  R26,LOW(0xFA)
	BRNE _0x4F
; 0000 00CD   {
; 0000 00CE    m4=255;
	LDI  R30,LOW(255)
	STS  _m4,R30
; 0000 00CF    return 4;
	LDI  R30,LOW(4)
	RET
; 0000 00D0    }
; 0000 00D1 if (m5==250)
_0x4F:
	LDS  R26,_m5
	CPI  R26,LOW(0xFA)
	BRNE _0x50
; 0000 00D2   {
; 0000 00D3    m5=255;
	LDI  R30,LOW(255)
	STS  _m5,R30
; 0000 00D4    return 5;
	LDI  R30,LOW(5)
	RET
; 0000 00D5    }
; 0000 00D6 if (m6==250)
_0x50:
	LDS  R26,_m6
	CPI  R26,LOW(0xFA)
	BRNE _0x51
; 0000 00D7   {
; 0000 00D8    m6=255;
	LDI  R30,LOW(255)
	STS  _m6,R30
; 0000 00D9    return 6;
	LDI  R30,LOW(6)
	RET
; 0000 00DA    }
; 0000 00DB  return 0;
_0x51:
_0x2040001:
	LDI  R30,LOW(0)
	RET
; 0000 00DC  }
;
;void Set_M(char mm,char dd)
; 0000 00DF {
_Set_M:
; 0000 00E0  switch (mm)
;	mm -> Y+1
;	dd -> Y+0
	LDD  R30,Y+1
	LDI  R31,0
; 0000 00E1  {
; 0000 00E2   case 1: PORTD.0=dd;
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x55
	LD   R30,Y
	CPI  R30,0
	BRNE _0x56
	CBI  0x12,0
	RJMP _0x57
_0x56:
	SBI  0x12,0
_0x57:
; 0000 00E3   break;
	RJMP _0x54
; 0000 00E4   case 2: PORTD.1=dd;
_0x55:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x58
	LD   R30,Y
	CPI  R30,0
	BRNE _0x59
	CBI  0x12,1
	RJMP _0x5A
_0x59:
	SBI  0x12,1
_0x5A:
; 0000 00E5   break;
	RJMP _0x54
; 0000 00E6   case 3: PORTD.2=dd;
_0x58:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x5B
	LD   R30,Y
	CPI  R30,0
	BRNE _0x5C
	CBI  0x12,2
	RJMP _0x5D
_0x5C:
	SBI  0x12,2
_0x5D:
; 0000 00E7   break;
	RJMP _0x54
; 0000 00E8   case 4: PORTD.3=dd;
_0x5B:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x5E
	LD   R30,Y
	CPI  R30,0
	BRNE _0x5F
	CBI  0x12,3
	RJMP _0x60
_0x5F:
	SBI  0x12,3
_0x60:
; 0000 00E9   break;
	RJMP _0x54
; 0000 00EA   case 5: PORTD.4=dd;
_0x5E:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x61
	LD   R30,Y
	CPI  R30,0
	BRNE _0x62
	CBI  0x12,4
	RJMP _0x63
_0x62:
	SBI  0x12,4
_0x63:
; 0000 00EB   break;
	RJMP _0x54
; 0000 00EC   case 6: PORTD.5=dd;
_0x61:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BRNE _0x54
	LD   R30,Y
	CPI  R30,0
	BRNE _0x65
	CBI  0x12,5
	RJMP _0x66
_0x65:
	SBI  0x12,5
_0x66:
; 0000 00ED   break;
; 0000 00EE  }
_0x54:
; 0000 00EF }
	ADIW R28,2
	RET
;
;void main(void)
; 0000 00F2 {
_main:
; 0000 00F3 PORTA=0xFE;
	LDI  R30,LOW(254)
	OUT  0x1B,R30
; 0000 00F4 DDRA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1A,R30
; 0000 00F5 PORTB=0x00;
	OUT  0x18,R30
; 0000 00F6 DDRB=0xB3;
	LDI  R30,LOW(179)
	OUT  0x17,R30
; 0000 00F7 PORTC=0xFF;
	LDI  R30,LOW(255)
	OUT  0x15,R30
; 0000 00F8 DDRC=0x00;
	LDI  R30,LOW(0)
	OUT  0x14,R30
; 0000 00F9 PORTD=0x00;
	OUT  0x12,R30
; 0000 00FA DDRD=0xFF;
	LDI  R30,LOW(255)
	OUT  0x11,R30
; 0000 00FB TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
; 0000 00FC TCNT0=0x00;
	OUT  0x32,R30
; 0000 00FD OCR0=0x00;
	OUT  0x3C,R30
; 0000 00FE TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 00FF TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 0100 TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 0101 TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 0102 ICR1H=0x00;
	OUT  0x27,R30
; 0000 0103 ICR1L=0x00;
	OUT  0x26,R30
; 0000 0104 OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 0105 OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 0106 OCR1BH=0x00;
	OUT  0x29,R30
; 0000 0107 OCR1BL=0x00;
	OUT  0x28,R30
; 0000 0108 ASSR=0x00;
	OUT  0x22,R30
; 0000 0109 TCCR2=0x69;
	LDI  R30,LOW(105)
	OUT  0x25,R30
; 0000 010A TCNT2=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
; 0000 010B OCR2=0x00;
	OUT  0x23,R30
; 0000 010C MCUCR=0x00;
	OUT  0x35,R30
; 0000 010D MCUCSR=0x00;
	OUT  0x34,R30
; 0000 010E TIMSK=0x00;
	OUT  0x39,R30
; 0000 010F ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 0110 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 0111 ADMUX=ADC_VREF_TYPE & 0xff;
	LDI  R30,LOW(32)
	OUT  0x7,R30
; 0000 0112 ADCSRA=0x8D;
	LDI  R30,LOW(141)
	OUT  0x6,R30
; 0000 0113 SPCR=0x50;
	LDI  R30,LOW(80)
	OUT  0xD,R30
; 0000 0114 SPSR=0x00;
	LDI  R30,LOW(0)
	OUT  0xE,R30
; 0000 0115 
; 0000 0116 i=0;
	STS  _i,R30
; 0000 0117 mode=0;
	STS  _mode,R30
; 0000 0118 flag=0;
	STS  _flag,R30
; 0000 0119 index=0;
	STS  _index,R30
	STS  _index+1,R30
; 0000 011A rec=0;
	STS  _rec,R30
; 0000 011B m1=0;
	STS  _m1,R30
; 0000 011C m2=0;
	STS  _m2,R30
; 0000 011D m3=0;
	STS  _m3,R30
; 0000 011E m4=0;
	STS  _m4,R30
; 0000 011F m5=0;
	STS  _m5,R30
; 0000 0120 m6=0;
	STS  _m6,R30
; 0000 0121 
; 0000 0122 #asm("sei")
	sei
; 0000 0123 ADCSRA=0xEE;
	LDI  R30,LOW(238)
	OUT  0x6,R30
; 0000 0124 if (card_Init()) {PORTD=0xFF; powerdown();}
	RCALL _card_Init
	CPI  R30,0
	BREQ _0x67
	LDI  R30,LOW(255)
	OUT  0x12,R30
	CALL _powerdown
; 0000 0125 sizef=0xFE-(PINA & 0xFE);
_0x67:
	IN   R30,0x19
	ANDI R30,0xFE
	LDI  R31,0
	LDI  R26,LOW(254)
	LDI  R27,HIGH(254)
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	CALL __CWD1
	STS  _sizef,R30
	STS  _sizef+1,R31
	STS  _sizef+2,R22
	STS  _sizef+3,R23
; 0000 0126 if ( sizef==0) sizef=1;
	CALL __CPD10
	BRNE _0x68
	__GETD1N 0x1
	STS  _sizef,R30
	STS  _sizef+1,R31
	STS  _sizef+2,R22
	STS  _sizef+3,R23
; 0000 0127 fullsectors=0x8000*sizef;
_0x68:
	LDS  R30,_sizef
	LDS  R31,_sizef+1
	LDS  R22,_sizef+2
	LDS  R23,_sizef+3
	__GETD2N 0x8000
	CALL __MULD12U
	STS  _fullsectors,R30
	STS  _fullsectors+1,R31
	STS  _fullsectors+2,R22
	STS  _fullsectors+3,R23
; 0000 0128 MaxSector = ((fullsectors*0.9)/6)-10;
	CALL __CDF1U
	__GETD2N 0x3F666666
	CALL __MULF12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x40C00000
	CALL __DIVF21
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x41200000
	CALL __SWAPD12
	CALL __SUBF12
	LDI  R26,LOW(_MaxSector)
	LDI  R27,HIGH(_MaxSector)
	CALL __CFD1U
	CALL __PUTDP1
; 0000 0129 StartSec[0]=0;
	LDI  R30,LOW(0)
	STS  _StartSec,R30
	STS  _StartSec+1,R30
	STS  _StartSec+2,R30
	STS  _StartSec+3,R30
; 0000 012A StartSec[1]=MaxSector+5;
	LDS  R30,_MaxSector
	LDS  R31,_MaxSector+1
	LDS  R22,_MaxSector+2
	LDS  R23,_MaxSector+3
	__ADDD1N 5
	__PUTD1MN _StartSec,4
; 0000 012B StartSec[2]=(MaxSector+5)*2;
	LDS  R30,_MaxSector
	LDS  R31,_MaxSector+1
	LDS  R22,_MaxSector+2
	LDS  R23,_MaxSector+3
	__ADDD1N 5
	CALL __LSLD1
	__PUTD1MN _StartSec,8
; 0000 012C StartSec[3]=(MaxSector+5)*3;
	LDS  R30,_MaxSector
	LDS  R31,_MaxSector+1
	LDS  R22,_MaxSector+2
	LDS  R23,_MaxSector+3
	__ADDD1N 5
	__GETD2N 0x3
	CALL __MULD12U
	__PUTD1MN _StartSec,12
; 0000 012D StartSec[4]=(MaxSector+5)*4;
	LDS  R30,_MaxSector
	LDS  R31,_MaxSector+1
	LDS  R22,_MaxSector+2
	LDS  R23,_MaxSector+3
	__ADDD1N 5
	CALL __LSLD1
	CALL __LSLD1
	__PUTD1MN _StartSec,16
; 0000 012E StartSec[5]=(MaxSector+5)*5;
	LDS  R30,_MaxSector
	LDS  R31,_MaxSector+1
	LDS  R22,_MaxSector+2
	LDS  R23,_MaxSector+3
	__ADDD1N 5
	__GETD2N 0x5
	CALL __MULD12U
	__PUTD1MN _StartSec,20
; 0000 012F 
; 0000 0130 while (1)
_0x69:
; 0000 0131  {
; 0000 0132       if(!PINC.7) mode=3;
	SBIC 0x13,7
	RJMP _0x6C
	LDI  R30,LOW(3)
	RJMP _0xA8
; 0000 0133       else  mode=0;
_0x6C:
	LDI  R30,LOW(0)
_0xA8:
	STS  _mode,R30
; 0000 0134       if (GetB_RECORD())
	RCALL _GetB_RECORD
	CPI  R30,0
	BRNE PC+3
	JMP _0x6E
; 0000 0135       {
; 0000 0136        PORTD.6=1;
	SBI  0x12,6
; 0000 0137        while (i==0)
_0x71:
	LDS  R30,_i
	CPI  R30,0
	BREQ PC+3
	JMP _0x73
; 0000 0138        {
; 0000 0139        if (GetB_RECORD())  { PORTD.6=0; break;}
	RCALL _GetB_RECORD
	CPI  R30,0
	BREQ _0x74
	CBI  0x12,6
	RJMP _0x73
; 0000 013A        else
_0x74:
; 0000 013B        {
; 0000 013C        i=GetB_M();
	RCALL _GetB_M
	STS  _i,R30
; 0000 013D        if (i)
	CPI  R30,0
	BRNE PC+3
	JMP _0x78
; 0000 013E        {
; 0000 013F         Set_M(i,1);
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _Set_M
; 0000 0140         carentsector=StartSec[i-1];
	LDS  R30,_i
	LDI  R31,0
	SBIW R30,1
	LDI  R26,LOW(_StartSec)
	LDI  R27,HIGH(_StartSec)
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETD1P
	STS  _carentsector,R30
	STS  _carentsector+1,R31
	STS  _carentsector+2,R22
	STS  _carentsector+3,R23
; 0000 0141         index=3;
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	STS  _index,R30
	STS  _index+1,R31
; 0000 0142         flag=0;
	LDI  R30,LOW(0)
	STS  _flag,R30
; 0000 0143         mode=2;
	LDI  R30,LOW(2)
	STS  _mode,R30
; 0000 0144         PORTB.0=1;
	SBI  0x18,0
; 0000 0145         sec=0;
	LDI  R30,LOW(0)
	STS  _sec,R30
	STS  _sec+1,R30
	STS  _sec+2,R30
	STS  _sec+3,R30
; 0000 0146         while ((GetB_M()!=i)&(sec<MaxSector))
_0x7B:
	RCALL _GetB_M
	LDS  R26,_i
	CALL __NEB12
	MOV  R0,R30
	LDS  R30,_MaxSector
	LDS  R31,_MaxSector+1
	LDS  R22,_MaxSector+2
	LDS  R23,_MaxSector+3
	LDS  R26,_sec
	LDS  R27,_sec+1
	LDS  R24,_sec+2
	LDS  R25,_sec+3
	CALL __LTD12U
	AND  R30,R0
	BRNE PC+3
	JMP _0x7D
; 0000 0147         {
; 0000 0148          while (flag==0);
_0x7E:
	LDS  R30,_flag
	CPI  R30,0
	BREQ _0x7E
; 0000 0149          if (card_WriteSector(carentsector+sec,bufb)){PORTD=0xFF; powerdown();}
	LDS  R30,_sec
	LDS  R31,_sec+1
	LDS  R22,_sec+2
	LDS  R23,_sec+3
	LDS  R26,_carentsector
	LDS  R27,_carentsector+1
	LDS  R24,_carentsector+2
	LDS  R25,_carentsector+3
	CALL __ADDD12
	CALL __PUTPARD1
	LDI  R30,LOW(_bufb)
	LDI  R31,HIGH(_bufb)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _card_WriteSector
	CPI  R30,0
	BREQ _0x81
	LDI  R30,LOW(255)
	OUT  0x12,R30
	CALL _powerdown
; 0000 014A          sec++;
_0x81:
	LDI  R26,LOW(_sec)
	LDI  R27,HIGH(_sec)
	CALL __GETD1P_INC
	__SUBD1N -1
	CALL __PUTDP1_DEC
; 0000 014B          while (flag==0xFF);
_0x82:
	LDS  R26,_flag
	CPI  R26,LOW(0xFF)
	BREQ _0x82
; 0000 014C          if (card_WriteSector(carentsector+sec,bufa)){PORTD=0xFF; powerdown();}
	LDS  R30,_sec
	LDS  R31,_sec+1
	LDS  R22,_sec+2
	LDS  R23,_sec+3
	LDS  R26,_carentsector
	LDS  R27,_carentsector+1
	LDS  R24,_carentsector+2
	LDS  R25,_carentsector+3
	CALL __ADDD12
	CALL __PUTPARD1
	LDI  R30,LOW(_bufa)
	LDI  R31,HIGH(_bufa)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _card_WriteSector
	CPI  R30,0
	BREQ _0x85
	LDI  R30,LOW(255)
	OUT  0x12,R30
	CALL _powerdown
; 0000 014D          sec++;
_0x85:
	LDI  R26,LOW(_sec)
	LDI  R27,HIGH(_sec)
	CALL __GETD1P_INC
	__SUBD1N -1
	CALL __PUTDP1_DEC
; 0000 014E         }
	RJMP _0x7B
_0x7D:
; 0000 014F        }
; 0000 0150        }
_0x78:
; 0000 0151        }
	RJMP _0x71
_0x73:
; 0000 0152        mode=0;
	LDI  R30,LOW(0)
	STS  _mode,R30
; 0000 0153 
; 0000 0154        if (card_ReadSector(StartSec[i-1],bufa)){PORTD=0xFF; powerdown();}
	LDS  R30,_i
	LDI  R31,0
	SBIW R30,1
	LDI  R26,LOW(_StartSec)
	LDI  R27,HIGH(_StartSec)
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETD1P
	CALL __PUTPARD1
	LDI  R30,LOW(_bufa)
	LDI  R31,HIGH(_bufa)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _card_ReadSector
	CPI  R30,0
	BREQ _0x86
	LDI  R30,LOW(255)
	OUT  0x12,R30
	CALL _powerdown
; 0000 0155        bufa[0]=sec;
_0x86:
	LDS  R30,_sec
	STS  _bufa,R30
; 0000 0156        bufa[1]=sec>>8;
	LDS  R26,_sec
	LDS  R27,_sec+1
	LDS  R24,_sec+2
	LDS  R25,_sec+3
	LDI  R30,LOW(8)
	CALL __LSRD12
	__PUTB1MN _bufa,1
; 0000 0157        bufa[2]=sec>>16;
	LDS  R30,_sec
	LDS  R31,_sec+1
	LDS  R22,_sec+2
	LDS  R23,_sec+3
	CALL __LSRD16
	__PUTB1MN _bufa,2
; 0000 0158        bufa[3]=sec>>24;
	LDI  R30,LOW(24)
	CALL __LSRD12
	__PUTB1MN _bufa,3
; 0000 0159        if (card_WriteSector(StartSec[i-1],bufa)){PORTD=0xFF; powerdown();}
	LDS  R30,_i
	LDI  R31,0
	SBIW R30,1
	LDI  R26,LOW(_StartSec)
	LDI  R27,HIGH(_StartSec)
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETD1P
	CALL __PUTPARD1
	LDI  R30,LOW(_bufa)
	LDI  R31,HIGH(_bufa)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _card_WriteSector
	CPI  R30,0
	BREQ _0x87
	LDI  R30,LOW(255)
	OUT  0x12,R30
	CALL _powerdown
; 0000 015A        PORTD=0;
_0x87:
	LDI  R30,LOW(0)
	OUT  0x12,R30
; 0000 015B        PORTB.0=0;
	CBI  0x18,0
; 0000 015C       }
; 0000 015D       else
	RJMP _0x8A
_0x6E:
; 0000 015E       {
; 0000 015F        PORTD.6=0;
	CBI  0x12,6
; 0000 0160        i=GetB_M();
	RCALL _GetB_M
	STS  _i,R30
; 0000 0161        if (i)
	CPI  R30,0
	BRNE PC+3
	JMP _0x8D
; 0000 0162        {
; 0000 0163         Set_M(i,1);
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _Set_M
; 0000 0164         carentsector=StartSec[i-1];
	LDS  R30,_i
	LDI  R31,0
	SBIW R30,1
	LDI  R26,LOW(_StartSec)
	LDI  R27,HIGH(_StartSec)
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETD1P
	STS  _carentsector,R30
	STS  _carentsector+1,R31
	STS  _carentsector+2,R22
	STS  _carentsector+3,R23
; 0000 0165         if (card_ReadSector(StartSec[i-1],bufa)){PORTD=0xFF; powerdown();}
	LDS  R30,_i
	LDI  R31,0
	SBIW R30,1
	LDI  R26,LOW(_StartSec)
	LDI  R27,HIGH(_StartSec)
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETD1P
	CALL __PUTPARD1
	LDI  R30,LOW(_bufa)
	LDI  R31,HIGH(_bufa)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _card_ReadSector
	CPI  R30,0
	BREQ _0x8E
	LDI  R30,LOW(255)
	OUT  0x12,R30
	CALL _powerdown
; 0000 0166         sec=bufa[0];
_0x8E:
	LDS  R30,_bufa
	CLR  R31
	CLR  R22
	CLR  R23
	STS  _sec,R30
	STS  _sec+1,R31
	STS  _sec+2,R22
	STS  _sec+3,R23
; 0000 0167         MaxSector1=sec;
	STS  _MaxSector1,R30
	STS  _MaxSector1+1,R31
	STS  _MaxSector1+2,R22
	STS  _MaxSector1+3,R23
; 0000 0168         sec=bufa[1];
	__GETB1MN _bufa,1
	CLR  R31
	CLR  R22
	CLR  R23
	STS  _sec,R30
	STS  _sec+1,R31
	STS  _sec+2,R22
	STS  _sec+3,R23
; 0000 0169         MaxSector1=MaxSector1+(sec<<8);
	LDS  R26,_sec
	LDS  R27,_sec+1
	LDS  R24,_sec+2
	LDS  R25,_sec+3
	LDI  R30,LOW(8)
	CALL __LSLD12
	LDS  R26,_MaxSector1
	LDS  R27,_MaxSector1+1
	LDS  R24,_MaxSector1+2
	LDS  R25,_MaxSector1+3
	CALL __ADDD12
	STS  _MaxSector1,R30
	STS  _MaxSector1+1,R31
	STS  _MaxSector1+2,R22
	STS  _MaxSector1+3,R23
; 0000 016A         sec=bufa[2];
	__GETB1MN _bufa,2
	CLR  R31
	CLR  R22
	CLR  R23
	STS  _sec,R30
	STS  _sec+1,R31
	STS  _sec+2,R22
	STS  _sec+3,R23
; 0000 016B         MaxSector1=MaxSector1+(sec<<16);
	CALL __LSLD16
	LDS  R26,_MaxSector1
	LDS  R27,_MaxSector1+1
	LDS  R24,_MaxSector1+2
	LDS  R25,_MaxSector1+3
	CALL __ADDD12
	STS  _MaxSector1,R30
	STS  _MaxSector1+1,R31
	STS  _MaxSector1+2,R22
	STS  _MaxSector1+3,R23
; 0000 016C         sec=bufa[3];
	__GETB1MN _bufa,3
	CLR  R31
	CLR  R22
	CLR  R23
	STS  _sec,R30
	STS  _sec+1,R31
	STS  _sec+2,R22
	STS  _sec+3,R23
; 0000 016D         MaxSector1=MaxSector1+(sec<<24);
	LDS  R26,_sec
	LDS  R27,_sec+1
	LDS  R24,_sec+2
	LDS  R25,_sec+3
	LDI  R30,LOW(24)
	CALL __LSLD12
	LDS  R26,_MaxSector1
	LDS  R27,_MaxSector1+1
	LDS  R24,_MaxSector1+2
	LDS  R25,_MaxSector1+3
	CALL __ADDD12
	STS  _MaxSector1,R30
	STS  _MaxSector1+1,R31
	STS  _MaxSector1+2,R22
	STS  _MaxSector1+3,R23
; 0000 016E         index=3;
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	STS  _index,R30
	STS  _index+1,R31
; 0000 016F         flag=0;
	LDI  R30,LOW(0)
	STS  _flag,R30
; 0000 0170         mode=1;
	LDI  R30,LOW(1)
	STS  _mode,R30
; 0000 0171         PORTB.1=1;
	SBI  0x18,1
; 0000 0172         sec=0;
	LDI  R30,LOW(0)
	STS  _sec,R30
	STS  _sec+1,R30
	STS  _sec+2,R30
	STS  _sec+3,R30
; 0000 0173         while ((GetB_M()!=i)&(sec<MaxSector1))
_0x91:
	RCALL _GetB_M
	LDS  R26,_i
	CALL __NEB12
	MOV  R0,R30
	LDS  R30,_MaxSector1
	LDS  R31,_MaxSector1+1
	LDS  R22,_MaxSector1+2
	LDS  R23,_MaxSector1+3
	LDS  R26,_sec
	LDS  R27,_sec+1
	LDS  R24,_sec+2
	LDS  R25,_sec+3
	CALL __LTD12U
	AND  R30,R0
	BRNE PC+3
	JMP _0x93
; 0000 0174         {
; 0000 0175          while (flag==0);
_0x94:
	LDS  R30,_flag
	CPI  R30,0
	BREQ _0x94
; 0000 0176          if (card_ReadSector(carentsector+sec,bufb)){PORTD=0xFF; powerdown();}
	LDS  R30,_sec
	LDS  R31,_sec+1
	LDS  R22,_sec+2
	LDS  R23,_sec+3
	LDS  R26,_carentsector
	LDS  R27,_carentsector+1
	LDS  R24,_carentsector+2
	LDS  R25,_carentsector+3
	CALL __ADDD12
	CALL __PUTPARD1
	LDI  R30,LOW(_bufb)
	LDI  R31,HIGH(_bufb)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _card_ReadSector
	CPI  R30,0
	BREQ _0x97
	LDI  R30,LOW(255)
	OUT  0x12,R30
	CALL _powerdown
; 0000 0177          sec++;
_0x97:
	LDI  R26,LOW(_sec)
	LDI  R27,HIGH(_sec)
	CALL __GETD1P_INC
	__SUBD1N -1
	CALL __PUTDP1_DEC
; 0000 0178          while (flag==0xFF);
_0x98:
	LDS  R26,_flag
	CPI  R26,LOW(0xFF)
	BREQ _0x98
; 0000 0179          if (card_ReadSector(carentsector+sec,bufa)){PORTD=0xFF; powerdown();}
	LDS  R30,_sec
	LDS  R31,_sec+1
	LDS  R22,_sec+2
	LDS  R23,_sec+3
	LDS  R26,_carentsector
	LDS  R27,_carentsector+1
	LDS  R24,_carentsector+2
	LDS  R25,_carentsector+3
	CALL __ADDD12
	CALL __PUTPARD1
	LDI  R30,LOW(_bufa)
	LDI  R31,HIGH(_bufa)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _card_ReadSector
	CPI  R30,0
	BREQ _0x9B
	LDI  R30,LOW(255)
	OUT  0x12,R30
	CALL _powerdown
; 0000 017A          sec++;
_0x9B:
	LDI  R26,LOW(_sec)
	LDI  R27,HIGH(_sec)
	CALL __GETD1P_INC
	__SUBD1N -1
	CALL __PUTDP1_DEC
; 0000 017B         }
	RJMP _0x91
_0x93:
; 0000 017C        mode=0;
	LDI  R30,LOW(0)
	STS  _mode,R30
; 0000 017D        PORTB.1=0;
	CBI  0x18,1
; 0000 017E        PORTD=0;
	OUT  0x12,R30
; 0000 017F        }
; 0000 0180       }
_0x8D:
_0x8A:
; 0000 0181       }
	RJMP _0x69
; 0000 0182 }
_0x9E:
	RJMP _0x9E
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_powerdown:
   in   r30,power_ctrl_reg
   cbr  r30,__sm_mask
   sbr  r30,__sm_powerdown
   out  power_ctrl_reg,r30
   in   r30,sreg
   sei
   sleep
   out  sreg,r30
	RET
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_spi:
	LD   R30,Y
	OUT  0xF,R30
_0x2020003:
	SBIS 0xE,7
	RJMP _0x2020003
	IN   R30,0xF
	ADIW R28,1
	RET

	.DSEG
_i:
	.BYTE 0x1
_mode:
	.BYTE 0x1
_flag:
	.BYTE 0x1
_rec:
	.BYTE 0x1
_m1:
	.BYTE 0x1
_m2:
	.BYTE 0x1
_m3:
	.BYTE 0x1
_m4:
	.BYTE 0x1
_m5:
	.BYTE 0x1
_m6:
	.BYTE 0x1
_index:
	.BYTE 0x2
_carentsector:
	.BYTE 0x4
_MaxSector:
	.BYTE 0x4
_MaxSector1:
	.BYTE 0x4
_sec:
	.BYTE 0x4
_fullsectors:
	.BYTE 0x4
_sizef:
	.BYTE 0x4
_StartSec:
	.BYTE 0x18
_bufa:
	.BYTE 0x200
_bufb:
	.BYTE 0x200

	.CSEG

	.CSEG
__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF1211
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF1211:
	BRCC __ADDF128
	RJMP __ADDF129
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLD12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	MOVW R22,R24
	BREQ __LSLD12R
__LSLD12L:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R0
	BRNE __LSLD12L
__LSLD12R:
	RET

__LSRD12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	MOVW R22,R24
	BREQ __LSRD12R
__LSRD12L:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R0
	BRNE __LSRD12L
__LSRD12R:
	RET

__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__LSLD1:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	RET

__LSRD16:
	MOV  R30,R22
	MOV  R31,R23
	LDI  R22,0
	LDI  R23,0
	RET

__LSLD16:
	MOV  R22,R30
	MOV  R23,R31
	LDI  R30,0
	LDI  R31,0
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__NEB12:
	CP   R30,R26
	LDI  R30,1
	BRNE __NEB12T
	CLR  R30
__NEB12T:
	RET

__LTD12U:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R25,R23
	LDI  R30,1
	BRLO __LTD12UT
	CLR  R30
__LTD12UT:
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__GETD1P_INC:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X+
	RET

__PUTDP1:
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	RET

__PUTDP1_DEC:
	ST   -X,R23
	ST   -X,R22
	ST   -X,R31
	ST   -X,R30
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

;END OF CODE MARKER
__END_OF_CODE:
